<?
// revision control database 1.0.0-pre10

$revctrldb = array("1.0.0.0" => array("
CREATE DATABASE %%dbname%% ;
GRANT SELECT, INSERT, UPDATE, DELETE ON %%dbname%%.* TO %%dbuser%%@%%dbmachine%% IDENTIFIED BY '%%dbpassword%%' ;
USE %%dbname%% ;
CREATE TABLE configgroup
(
  ID INT(8) NOT NULL AUTO_INCREMENT,
  name TEXT,
  description TEXT,
  PRIMARY KEY(ID)
);
INSERT INTO configgroup (ID, name, description) values
 (1, 'Main', 'Main configuration'),
 (2, 'Security', 'Security configuration'),
 (3, 'Template', 'Template file definition');
CREATE TABLE config
(
  ID INT(8) NOT NULL AUTO_INCREMENT,
  GroupID INT(8) DEFAULT 1,
  item TEXT,
  description TEXT,
  val TEXT,
  PRIMARY KEY(ID)
);
INSERT INTO config (GroupID, item, description, val) values

 (3, 'pagetemplate', 'Main page template',
  'thcnetpage.template'),
 (3, 'subpagetemplate', 'Sub page template', 
  'thcnetsubpage.template'),
 (3, 'articletemplate', 'Article template',
  'thcnetarticle.template'),
 (3, 'formtemplate', 'Form template',
  'thcnetform.template'),
 (3, 'menutemplate', 'Menu function template', 
  'thcnetmenu.template'),
 (3, 'usertemplate', 'User info template',
  'thcnetuser.template'),
 (3, 'userlisttemplate', 'User listing template',
  'thcnetuserlist.template'),
 (3, 'articlenewcolor', 'Color of *New* link on new articles',
  '#fbb300'),
 
 (2, 'sysoplevel', 'Security level for system administrator', '255'),
 (2, 'adminlevel', 'Security level for administrators', '250'),
 (2, 'moderatorlevel', 'Security level for moderators', '200'),
 
 (1, 'defaultbase', 'Default base list on main page.  No value selects all bases.', ''),
 
 (1, 'defaultcount', 'Messages per page of historical archive', '10'),
 (1, 'listdefaultcount', 'Messages per page of brief message header listings', '20'),
 
 (1, 'sigmainpage', 'Display signatures on main page (0 = No, 1 = Yes)',
  '0'),
 (1, 'multiple_Re', 'Preappend multiple Re:\'s to title on message replies (0 = No, 1 = Yes)',
  '0'),
 (1, 'quotingmode', 'Default quoting mode (1 = Quote, 0 = Don\'t quote)',
  '1'),
 (1, 'threadingmode', 'Default threading mode (0 = Threaded, 1 = Nested)',
  '1'),

 (1, 'minmessagenumber', 'Minimum number of messages to display on main page',
  '7'),
 (1, 'minmessagedays', 'Minimum number of days of messages to display on main page',
  '2'),
 (1, 'maxreplyindent', 'Maximum depth of multiple reply indentations (0 = No limit)',
  '12'),

 (0, 'thcnetversion', 'THCNET Code version number.  DO NOT EDIT THIS VALUE',
  '1.0.0.0');
CREATE TABLE threadindex
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  BoardID INT(8) NOT NULL,
  ArticleID INT(11) NOT NULL,
  ReplyCount INT(8),
  date_time datetime NOT NULL,
  last_date datetime,
  PRIMARY KEY(ID),
  INDEX (date_time)
);
CREATE TABLE articles
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  BoardID INT(8) NOT NULL,
  ReplyID INT(11) NOT NULL,
  UserID INT(8),
  date_time datetime NOT NULL,
  Title VARCHAR(128),
  messagetextID INT(11) NOT NULL,
  moderation VARCHAR(2),
  PRIMARY KEY(ID),
  INDEX (ReplyID,date_time)
);
CREATE TABLE messagetext
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  Article LONGTEXT,
  PRIMARY KEY(ID)
);
CREATE TABLE threadlastread
(
  UserID INT(8) NOT NULL,
  ThreadID INT(11) NOT NULL,
  lastread datetime,
  oldlastread datetime,
  session VARCHAR(8),
  oldsession VARCHAR(8),
  INDEX (UserID,ThreadID)
);
CREATE TABLE msgboards
(
  ID INT(8) NOT NULL AUTO_INCREMENT,
  Name TEXT,
  Description LONGTEXT,
  OwnerID INT(8),
  ReadAccess INT(3),
  PostAccess INT(3),
  ModeratedAccess INT(3),
  ModeratorAccess INT(3),
  PRIMARY KEY(ID)
);
insert into msgboards (Name, Description, OwnerID, ReadAccess, PostAccess, ModeratedAccess, ModeratorAccess)
values ('Main', 'Main message board', 1, 0, 0, 150, 250);
insert into msgboards (Name, Description, OwnerID, ReadAccess, PostAccess, ModeratedAccess, ModeratorAccess)
values ('Calendar', 'Calendar', 1, 0, 150, 150, 250);
insert into msgboards (Name, Description, OwnerID, ReadAccess, PostAccess, ModeratedAccess, ModeratorAccess)
values ('Private', 'Private message board', 1, 150, 150, 150, 250);
CREATE TABLE users
(
  ID INT(8) NOT NULL AUTO_INCREMENT,
  Name VARCHAR(32),
  password VARCHAR(32),
  email VARCHAR(32),

  personalinfo1 TEXT,
  personalinfo2 TEXT,
  personalinfo3 TEXT,

  admin INT(1),

  lastread DATETIME,
  messages INT(1),

  quotingmode INT(1),
  threadingmode INT(1) DEFAULT 1,
  minmessages INT(1),
  mindays INT(1),

  signature LONGTEXT,

  PRIMARY KEY(ID)
);

CREATE TABLE session
( 
  ID VARCHAR(8) NOT NULL,
  LastAction DATETIME, 
  LastLocatn TEXT,
  UserID VARCHAR(8),
  LastRead DATETIME,
  PRIMARY KEY(ID)
);

INSERT INTO threadindex (ID, BoardID, ArticleID, date_time)
VALUES (1, 1, 1, Now());
INSERT INTO articles (ID, BoardID, date_time, UserID, Title, messagetextID, moderation)
VALUES (1, 1, Now(), 1, 'Welcome to THCNET', 1, 1);
INSERT INTO messagetext (ID, Article)
VALUES (1, 'Welcome to the THCNET message system.<br>
<br>
Be sure to look at the README for installation instructions, as well as details on how to begin to customize THCNET for your needs.<br>');
", "initial configuration"),
  
  "1.0.0.5" => array("
USE %%dbname%% ;
UPDATE config SET val = '1.0.0.5' WHERE item = 'thcnetversion';
", "introduction of revcontrol system"),

  "1.0.0.6" => array("
USE %%dbname%% ;
INSERT INTO config (GroupID, item, description, val) values
 (1, 'maxreplyindentwrap', 'Reset reply indentation depth when max is reached (0 = No, 1 = Yes)',
  '1'),
 (3, 'dateformat', 'Date output format (see http://php.net/manual/en/function.date.php)',
  'l F j, Y @ h:ia') ;
UPDATE config SET val = '!Calendar' WHERE item = 'defaultbase';
UPDATE config SET 
description = 'Default base list filter on main page. No entry defaults to all bases or not filtered (base1,base2 = base1 and base2 | !base1 = not base1)'
WHERE item = 'defaultbase';
UPDATE config SET val = '1.0.0.6' WHERE item = 'thcnetversion';
", "tweak of max reply indentation mode"),

  "1.0.0.7" => array("
USE %%dbname%% ;
CREATE TABLE syslog
( 
  ID INT(11) NOT NULL AUTO_INCREMENT,
  date_time DATETIME, 
  UserID VARCHAR(8),
  message TEXT,
  PRIMARY KEY(ID)
);
INSERT INTO config (GroupID, item, description, val) values
 (1, 'maxsyslogdisplay', 'Maximum number of syslog entries to display to user',
  '3');
UPDATE config SET val = '1.0.0.7' WHERE item = 'thcnetversion';
", "Added syslog feature"),

  "1.0.0.8" => array("
USE %%dbname%% ;
DELETE FROM config WHERE item = 'articlenewcolor';
CREATE TABLE allowedhtml
(
  ID INT(8) NOT NULL AUTO_INCREMENT,
  source TEXT,
  translation TEXT,
  access INT(3),
  PRIMARY KEY(ID)
);
INSERT INTO allowedhtml (source, translation, access) VALUES
(\"&lt%%sem%%i&gt%%sem%%\", \"<i>\", 0),
(\"&lt%%sem%%/i&gt%%sem%%\", \"</i>\", 0),
(\"&lt%%sem%%u&gt%%sem%%\", \"<u>\", 0),
(\"&lt%%sem%%/u&gt%%sem%%\", \"</u>\", 0),
(\"&lt%%sem%%b&gt%%sem%%\", \"<b>\", 0),
(\"&lt%%sem%%/b&gt%%sem%%\", \"</b>\", 0),
(\"&lt%%sem%%ul&gt%%sem%%\", \"<ul>\", 0),
(\"&lt%%sem%%/ul&gt%%sem%%\", \"</ul>\", 0),
(\"&lt%%sem%%ol&gt%%sem%%\", \"<ol>\", 0),
(\"&lt%%sem%%/ol&gt%%sem%%\", \"</ol>\", 0),
(\"&lt%%sem%%li&gt%%sem%%\", \"<li>\", 0),
(\"&lt%%sem%%/li&gt%%sem%%\", \"</li>\", 0),
(\"&lt%%sem%%pre&gt%%sem%%\", \"<pre>\", 0),
(\"&lt%%sem%%/pre&gt%%sem%%\", \"</pre>\", 0),
(\"(&lt%%sem%%img src=\\\")([^\\\"]+)(\\\")(.?|[ ]border=[0-9]+|[ ]alt=\\\"[^\\\"]+\\\"|[ ]border=[0-9]+[ ]alt=\\\"[^\\\"]+\\\"|[ ]alt=\\\"[^\\\"]+\\\"[ ]border=[0-9]+)(&gt%%sem%%)\",
 \"<img src=\\\"\\\\2\\\"\\\\4>\", 150);
ALTER TABLE users ADD COLUMN maxdays int(1) DEFAULT 0 after mindays ;
ALTER TABLE users ADD COLUMN previewmode int(1) after quotingmode ;
OPTIMIZE TABLE users ;
ALTER TABLE msgboards ADD COLUMN Image text after Description ;
OPTIMIZE TABLE msgboards ;
UPDATE msgboards SET Image = \"\" WHERE Name = \"Main\" ;
UPDATE msgboards SET Image = \"pics/topiccalendar.gif\" WHERE Name = \"Calendar\" ;
UPDATE msgboards SET Image = \"pics/topicprivate.gif\" WHERE Name = \"Private\" ;
INSERT INTO config (GroupID, item, description, val) values
 (1, 'previewmode', 'Default message preview mode on post. (1=preview,&nbsp%%sem%%0=post)',
  '1') ;
INSERT INTO config (GroupID, item, description, val) values
 (1, 'maxmessagedays', 'Maximum number of days of messages to display on main page after user has stopped looking at the thread.',
  '0') ;
ALTER TABLE articles ADD COLUMN ThreadID INT(11) AFTER ReplyID;
UPDATE config SET val = '1.0.0.8' WHERE item = 'thcnetversion';
", ""),

  "1.0.0.9" => array("
USE %%dbname%% ;
ALTER TABLE users ADD logins INT(1) AFTER messages;
ALTER TABLE users CHANGE COLUMN messages messages INT(1) DEFAULT 0;
UPDATE users SET messages = 0 WHERE messages IS NULL;
INSERT INTO allowedhtml (source, translation, access) VALUES
(\"%%\", \"&#37%%sem%%&#37%%sem%%\", 0);
INSERT INTO config (GroupID, item, description, val) values
 (1, 'anonymoususer', 'Display name of anonymous users.',
  'Anonymous Bastard') ;
UPDATE config SET val = '0' WHERE item = 'maxmessagedays';
UPDATE config SET val = '1.0.0.9' WHERE item = 'thcnetversion';
", ""),

  "1.0.0.A" => array("
USE %%dbname%% ;
DELETE FROM config WHERE item = 'menutemplate';
INSERT INTO config (GroupID, item, description, val) values
 (1, 'onlinetime', 'Time idle in seconds where users are still shown to be online.',
  '600') ;
INSERT INTO config (GroupID, item, description, val) values
 (1, 'messageindent', 'Amount of space to indent replies.',
  '20') ;
UPDATE config SET val = '1.0.0.A' WHERE item = 'thcnetversion';
", ""),

  "1.0.0.B" => array("
USE %%dbname%% ;
ALTER TABLE articles ADD COLUMN child_date_time datetime AFTER date_time;
UPDATE config SET val = '1.0.0.B' WHERE item = 'thcnetversion';
",""),

  "1.0.0.C" => array("
USE %%dbname%% ;
INSERT INTO configgroup (ID, name, description) values
 (4, 'Sections', 'Section Descriptions');
INSERT INTO config (GroupID, item, description, val) values
 (4, 'location:', 'Default description',
  'Welcome to THCNET'),
 (4, 'location:article', 'Article',
  'Article'),
 (4, 'location:reply', 'Post a Reply',
  'Post a Reply'),
 (4, 'location:edit', 'Edit Message',
  'Edit Message'),
 (4, 'location:moderate', 'Message Moderation',
  'Message Moderation'),
 (4, 'location:userlist', 'User Listing',
  'User Listing'),
 (4, 'location:archive', 'Historical Archive',
  'Historical Archive'),
 (4, 'location:msgform', 'Post a Message',
  'Post a Message'),
 (4, 'location:userinfo', 'User Information %%user%%',
  'User Information %%user%%'),
 (4, 'location:admin', 'Admin',
  'Admin'),
 (4, 'location:sqladmin', 'SQL Admin',
  'SQL Admin'),
 (4, 'location:msgbadmin', 'Message Board Admin',
  'Message Board Admin'),
 (4, 'location:htmladmin', 'Allowed HTML Admin',
  'Allowed HTML Admin'),
 (4, 'location:templateadmin', 'Template Admin',
  'Template Admin'),
 (4, 'location:login', 'Login Form',
  'Login'),
 (4, 'location:apply', 'First Apply Apply',
  'Apply'),
 (4, 'location:apply2', 'Second Apply Screen',
  'Apply');
ALTER TABLE users ADD COLUMN total_pages int(1) AFTER messages;
ALTER TABLE users ADD COLUMN total_replies int(1) AFTER messages;
ALTER TABLE users ADD COLUMN total_logins int(1) AFTER logins;
ALTER TABLE users ADD COLUMN total_messages int(1) AFTER logins;
INSERT INTO config (GroupID, item, description, val) values
 (3, 'posttemplate', 'Message Form template',
  'thcnetpost.template');
UPDATE config SET val = '1.0.0.C' WHERE item = 'thcnetversion';
",""),

  "1.0.0.D" => array("
USE %%dbname%% ;
CREATE TABLE polls
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  BoardID INT(8) NOT NULL,
  ThreadID INT(11) NOT NULL,
  date_time datetime NOT NULL,
  Title VARCHAR(128),
  Text TEXT,
  allowadds INT(1),
  votes INT(1),
  PRIMARY KEY(ID),
  INDEX (date_time)
);
CREATE TABLE pollchoices
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  PollID INT(11) NOT NULL,
  UserID INT(11) NOT NULL,
  Choice VARCHAR(128),
  PRIMARY KEY(ID),
  INDEX (PollID)
);
CREATE TABLE pollvotes
(
  ID INT(11) NOT NULL AUTO_INCREMENT,
  ChoiceID INT(11) NOT NULL,
  UserID INT(11) NOT NULL,
  IPAddr CHAR(16),
  date_time datetime NOT NULL,
  PRIMARY KEY(ID)
);
INSERT INTO configgroup (ID, name, description) values
 (5, 'Polls', 'Poll options');
INSERT INTO config (GroupID, item, description, val) values
 (5, 'pollvotesperday', 'Votes allowed per user per day (0 unlimited)',
  '1'),
 (5, 'polluniqueuser', 'Track unique votes by user', 
  '1'),
 (5, 'polluniqueip', 'Track unique votes by IP address', 
  '1'),
 (3, 'polltemplate', 'Poll template',
  'thcnetpoll.template');
UPDATE config SET description = 'Default threading mode (0=Nested, 1=Threaded)' WHERE item = 'threadingmode';
UPDATE config SET val = 0 WHERE item = 'threadingmode';
UPDATE users SET threadingmode = 0;
INSERT INTO config (GroupID, item, description, val) values
 (4, 'location:preview', 'Preview Your Message',
  'Preview Your Message');
UPDATE config SET val = '1.0.0.D' WHERE item = 'thcnetversion';
",""),

  "1.0.0.E" => array("
USE %%dbname%% ;
ALTER TABLE messagetext RENAME TO oldmessagetext;
CREATE TABLE messagetext (
  ID int(11) NOT NULL auto_increment,
  Title text,
  Article longtext,
  PRIMARY KEY  (ID)
) TYPE=MyISAM PACK_KEYS=1;
INSERT INTO messagetext (ID, Title, Article) SELECT oldmessagetext.ID, articles.Title, oldmessagetext.Article 
FROM articles LEFT JOIN oldmessagetext ON articles.messagetextID = oldmessagetext.ID;
ALTER TABLE messagetext ADD FULLTEXT (Title, Article);
DROP TABLE oldmessagetext;
ALTER TABLE articles DROP COLUMN Title;
OPTIMIZE TABLE articles ;
UPDATE config SET val = '1.0.0.E' WHERE item = 'thcnetversion';
","")


);


function reindexarticles()
{
  global $mysql_link;

  // this part takes a long time
  ignore_user_abort(true); 
  $counter = 0;

  print("Reindexing articles.  This may take awile...<br>\n");

  $query = "SELECT ID, ReplyID FROM articles ";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // script is still running so bump up the time limit.
    set_time_limit(30);

    if($row[1])
    {
      $original_ReplyID = $row[1];
    }
    else
    {
      $original_ReplyID = $row[0];
    }
    $temp_ReplyID = $row[1];

    while($temp_ReplyID != 0)         
    {
      $Query = "SELECT ReplyID FROM articles ";
      $Query .= "WHERE ID = '$temp_ReplyID'";
      $mysql_result2 = mysql_query($Query, $mysql_link);

      $prev_ReplyID = $temp_ReplyID;
      while($row2 = mysql_fetch_row($mysql_result2))
      {
        $original_ReplyID = $temp_ReplyID;
        $temp_ReplyID = $row2[0];
      }
      if($prev_ReplyID == $temp_ReplyID)
      {
        // we have an orphaned message.  It should be marked deleted.
        $Query = "UPDATE articles SET moderation = '-3' "
          . "WHERE ID = '$row[0]' ";
        mysql_query($Query, $mysql_link);
        $temp_ReplyID = 0;
      }      
    }             
    print(".");
    ++$counter;
    if($counter > 49)
    {
      $total = $total + $counter;
      print("&nbsp;$total<br>\n");
      $counter = 0;
    }      

    $Query = "SELECT ID FROM threadindex "
      . "WHERE ArticleID = '$original_ReplyID' ";
    $mysql_result2 = mysql_query($Query, $mysql_link);

    while($row2 = mysql_fetch_row($mysql_result2))
    {
      $Query = "UPDATE articles SET ThreadID = '$row2[0]' "
        . "WHERE ID = '$row[0]' "; 
      mysql_query($Query, $mysql_link);
    }
  }
  
  print("Done.<br>\n");

}

function reindexchilddate()
{
  global $mysql_link;

  // this part takes a long time
  ignore_user_abort(true); 
  $counter = 0;

  print("Reindexing article child dates.  This may take awile...<br>\n");

  $query = "SELECT ID, ReplyID, date_time FROM articles ";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // script is still running so bump up the time limit.
    set_time_limit(30);

    $temp_ReplyID = $row[1];
    $temp_date_time = $row[2];

    if($temp_ReplyID != 0)         
    {
      $Query = "SELECT child_date_time FROM articles ";
      $Query .= "WHERE ID = '$temp_ReplyID'";
      $mysql_result2 = mysql_query($Query, $mysql_link);

      while($row2 = mysql_fetch_row($mysql_result2))
      {
        if($temp_date_time > $row2[0])
        {
          $Query = "UPDATE articles SET child_date_time = '$temp_date_time' WHERE ID = '$temp_ReplyID' ";
          mysql_query($Query, $mysql_link);
        }        
      }
    }             
    print(".");
    ++$counter;
    if($counter > 49)
    {
      $total = $total + $counter;
      print("&nbsp;$total<br>\n");
      $counter = 0;
    }      
  }
  
  print("Done.<br>\n");

}

function fixuserlogincounts()
{
  global $mysql_link;

  // this part takes a long time
  ignore_user_abort(true); 
  $counter = 0;

  print("Fixing user login totals.  This may take awile...<br>\n");

  $query = "UPDATE users SET logins = 1 WHERE logins <> 1 or logins is NULL";
  $mysql_result = mysql_query($query, $mysql_link);

  $query = "delete from syslog where UserID NOT like \"!%\" ";
  $mysql_result = mysql_query($query, $mysql_link);

  $query = "optimize table syslog ";
  $mysql_result = mysql_query($query, $mysql_link);

  $query = "select ID, UserID from syslog where message like '%logged in.' ";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // script is still running so bump up the time limit.
    set_time_limit(30);
    
    $item_UserID = substr($row[1],1);

    $query = "SELECT logins FROM users WHERE ID = '$item_UserID' "; 
    $mysql_result2 = mysql_query($query, $mysql_link);
    while($item = mysql_fetch_row($mysql_result2))
    {
      $item_logins = $item[0];

      $query = "UPDATE users SET logins = '";
      $query .= $item_logins + 1;
      $query .= "' WHERE ID = '$item_UserID' ";
      mysql_query($query, $mysql_link);
    }

    print(".");
    ++$counter;
    if($counter > 99)
    {
      $total = $total + $counter;
      print("&nbsp;$total<br>\n");
      $counter = 0;
    }      
  }
  print("Done.<br>\n");
}

function fixusermsgcounts()
{
  global $mysql_link;

  // this part takes a long time
  ignore_user_abort(true); 
  $counter = 0;

  print("Fixing user message totals.  This may take awile...<br>\n");

  $query = "UPDATE users SET messages = 0 WHERE messages <> 0 ";
  $mysql_result = mysql_query($query, $mysql_link);


  $query = "SELECT ID, UserID FROM articles ";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // script is still running so bump up the time limit.
    set_time_limit(30);

    $query = "UPDATE users SET messages = messages + 1 WHERE ID = '$row[1]' "; 
    mysql_query($query, $mysql_link);

    print(".");
    ++$counter;
    if($counter > 99)
    {
      $total = $total + $counter;
      print("&nbsp;$total<br>\n");
      $counter = 0;
    }      
  }
  print("Done.<br>\n");
}

function cleanthreadlastread()
{
  global $mysql_link;

  ignore_user_abort(true); 
  $counter = 0;

  print("Cleaning up Threadlastread totals.<br>\n");


  $query = "select threadlastread.UserID from threadlastread "
    . "left join users on threadlastread.UserID = users.ID "
    . "where IFNULL(users.ID,-1) = -1 ";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // script is still running so bump up the time limit.
    set_time_limit(30);

    $query = "DELETE FROM threadlastread WHERE UserID = '$row[1]' "; 
    mysql_query($query, $mysql_link);

    print(".");
    ++$counter;
    if($counter > 99)
    {
      $total = $total + $counter;
      print("&nbsp;$total<br>\n");
      $counter = 0;
    }      
  }

  $query = "optimize table threadlastread ";
  $mysql_result = mysql_query($query, $mysql_link);

  print("Done.<br>\n");
}

function removedupconfig()
{
  global $mysql_link;

  // checks for duplicate config items and removes them
  print("Checking config data for duplicates.<br>\n");

  $query = "SELECT ID, item, val FROM config";
  $mysql_result = mysql_query($query, $mysql_link);

  while($row = mysql_fetch_row($mysql_result))
  {
    // assign variable 'item' the value of 'val'
    if(isset($$row[1]))
    {
      print("Duplicate entry for '$row[1]'.  Deleting.<br>\n");
      $query = "DELETE FROM config WHERE ID = '$row[0]' ";
      mysql_query($query, $mysql_link);
    }
    else
    {
      $$row[1] = $row[2];
    }
  }
}

function removeduphtml()
{
  global $mysql_link;

  // checks for duplicate allowed html items and removes them
  print("Checking allowed html data for duplicates.<br>\n");

  $retry = 1;
  while($retry)
  {
    $query = "SELECT ID, source, translation, access FROM allowedhtml ORDER BY ID";
    $mysql_result = mysql_query($query, $mysql_link);

    while($row = mysql_fetch_row($mysql_result) and $retry != 2)
    {
      $query = "SELECT ID, source, translation, access FROM allowedhtml WHERE ID <> $row[0] ORDER BY ID";
      $mysql_result2 = mysql_query($query, $mysql_link);

      while($row2 = mysql_fetch_row($mysql_result2))
      {
        if($row[1] == $row2[1])
        {
          print("Duplicate entry for '$row[1]'.  Deleting.<br>\n");
          $query = "DELETE FROM allowedhtml WHERE ID = '$row2[0]' ";
          mysql_query($query, $mysql_link);
          $retry = 2;
        }
      }
    }
    if($retry != 2)
    {
      $retry = 0;
    }
    else
    {
      $retry = 1;
    }
  }
}

function revctrlverinfo($version)
{
  // returns the revision control notes
  global $revctrldb;
  $row=$revctrldb[$version];
  return $row[1];
}

function revctrlverapply($version)
{
  // applys a particular revision update
  global $revctrldb;
  global $dbname, $dbmachine, $dbuser, $dbpassword;
  global $dbadmin, $dbadminpassword;

  print("Applying THCNET version $version.<br>\n");

  $row=$revctrldb[$version];
  // sql update info contained in $row[0]

}

function revctrlverupdate($funct)
{
  global $revctrldb, $baseurl, $thcnetcodever;
  global $dbname, $dbmachine, $dbuser, $dbpassword;
  global $dbadmin, $dbadminpassword;
  global $inputdbuser, $inputdbpassword, $inputdbadmin, $inputdbadminpassword;
  global $inputdbmachine, $inputdbname;
  global $mysql_link;

  // check to see that we have disk access first
  if($inputdbname)
  {
    print("Checking file rights.<br>\n");
    writeconf();
  }

  if($inputdbname)
  {
    $dbname = $inputdbname;
    $dbmachine = $inputdbmachine;
    $dbuser = $inputdbuser;
    $dbpassword = $inputdbpassword;
  }
  
  if($inputdbadmin)
  {
    $dbadmin = $inputdbadmin;
    $dbadminpassword = $inputdbadminpassword;
  }
  else
  {
    $dbadmin = $dbuser;
    $dbadminpassword = $dbpassword;
  }

  $mysql_link = mysql_connect($dbmachine, $dbadmin, $dbadminpassword);
  if(!$mysql_link)
  {
    // database error display sql configuration setup
    print("<br>Error: unable to connect to database server.<br><br>");
    include_once("admin.functions.php");
    echo displaysqladmin("admin");
    exit;
  }

  foreach(array_keys($revctrldb) as $cols)
  {
    // insert a check for version number here
    if($cols > $funct)
    {
      print("Applying: $cols<br>\n");

      $row = $revctrldb[$cols];
      $row[0] = eregi_replace("%%dbname%%", $dbname, $row[0]);
      $row[0] = eregi_replace("%%dbmachine%%", $dbmachine, $row[0]);
      $row[0] = eregi_replace("%%dbuser%%", $dbuser, $row[0]);
      $row[0] = eregi_replace("%%dbpassword%%", $dbpassword, $row[0]);
      $row[0] = eregi_replace("\n","",$row[0]);
      $row[0] = eregi_replace("\r","",$row[0]);

      $sqlquery = split (";", $row[0]);    
      foreach(array_keys($sqlquery) as $query)
      {
        $sqlquery[$query] = eregi_replace("%%sem%%",";",$sqlquery[$query]);    
        mysql_query($sqlquery[$query],$mysql_link);
        if(mysql_errno() and mysql_errno() <> 1065)
        {
          print("<br>Error " . mysql_errno() . ": $sqlquery[$query]<br>" . mysql_error() . "<br>");
        }
      }

      if($cols == "1.0.0.8")
      {
        // threadid needs populated in version 1.0.0pre8
        reindexarticles();
      }
      if($cols == "1.0.0.9")
      {
        // more cleanup in case things were applied twice.  
        // Useful to cleanup after running partial alpha stage releases.
        fixusermsgcounts();
        fixuserlogincounts();
      }        
      if($cols == "1.0.0.B")
      {
        // more cleanup in case things were applied twice.  
        // Useful to cleanup after running partial alpha stage releases.
        reindexchilddate();
      }        
      if($cols == "1.0.0.C")
      {
        // more cleanup in case things were applied twice.  
        // Useful to cleanup after running partial alpha stage releases.
        cleanthreadlastread();
      }        
      removedupconfig();
      if($cols >= "1.0.0.8")
      {
        removeduphtml();
      }
    }
  }

  if($inputdbname)
  {
    print("Writing thcnetconf.php<br>\n");
    writeconf();
  }

  if($inputdbname)
  {
    print("<br>Setup complete.<br><br>Click on the following link, \n");
    print("<a href=\"$baseurl?section=apply\">$baseurl?section=apply</a>, ");
    print("and apply as a new user to create the system admin account.<br>\n");
  }
  else
  {
    print("<br>Upgrade complete.<br><br>Click on the following link to continue: \n");
    print("<a href=\"$baseurl\">$baseurl</a><br><br> ");
    print("Also, look at the UPGRADE and changelog text files for additional upgrade details.<br>\n");
  }
  exit;
}

function writeconf()
{
  // writes out the thcnetconf
  global $dbname, $dbmachine, $dbuser, $dbpassword;
  if($fileopen = fopen("thcnetconf.php", "w"))
  {
    $config="<?\n"
      . "\$dbname = \"$dbname\";\n"
      . "\$dbmachine = \"$dbmachine\";\n"
      . "\$dbuser = \"$dbuser\";\n"
      . "\$dbpassword = \"$dbpassword\";\n"
      . "?>\n";
    fwrite ($fileopen, $config);
    fclose($fileopen);
  } 
  else
  {
    print("<br><b>Error:</b> &nbsp;Unable to open <b>thcnetconf.php</b> for writing.<br>");
    print("<br>Check access permissions to ensure that the web server has permission to write the configuration file.<br>\n");
    exit;
  }
}

?>
